<?php

namespace WPPayFormPro\GateWays\Addons;

if (!defined('ABSPATH')) {
    exit;
}

class AddonHelper
{
    /*
    * Check if the plugin/addon has update
    * @param string $slug addon/plugin slug
    * @param string $org github organization
    * @return array contains available, url, slug
    */
    public static function checkUpdateFromGithub($slug, $org, $update = true)
    {
        $githubApi = "https://api.github.com/repos/{$org}/{$slug}/releases";
        $result = array(
            'available' => 'no',
            'url' => '',
            'slug' => 'xendit-payment-for-paymattic'
        );

        // $response = wp_remote_get($githubApi, 
        // [
        //     'headers' => array('Accept' => 'application/json',
        //     'authorization' => 'bearer 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')
        // ]);

        $response = wp_remote_get($githubApi);

        if (is_wp_error($response)) {
            return $result;
        }

        $releases = json_decode($response['body']);

        if (isset($releases->documentation_url)) {
            return $result;
        }

        $latestRelease = $releases[0];
        $latestVersion = $latestRelease->tag_name;
        $zipUrl = $latestRelease->zipball_url;

        if (!$update) {
            $result['available'] = 'no';
            $result['url'] = $zipUrl;
            return $result;
        }

        if (!function_exists('get_plugins')) {
            require_once ABSPATH . 'wp-admin/includes/plugin.php';
        }
    
        $plugins = get_plugins();
        $currentVersion = '';

        // Check if the plugin is present
        foreach ($plugins as $plugin_file => $plugin_data) {
            // Check if the plugin slug or name matches
            if ($slug === $plugin_data['TextDomain'] || $slug === $plugin_data['Name']) {
                $currentVersion = $plugin_data['Version'];
            }
        }

        if (version_compare( $latestVersion, $currentVersion, '>')) {
            $result['available'] = 'yes';
            $result['url'] = $zipUrl;
        }

        return $result;
    }
}