<?php

namespace WPPayFormPro\GateWays\Addons;

class Moneris
{
    public function init() {
        // in case we host it on wordpress org
        add_filter('wppayform_payment_method_settings', function($settings){
             $settings['moneris'] = array (
                'title' => 'Moneris',
                'route_name' => 'moneris',
                'route_query' => [],
                'svg' => WPPAYFORM_URL .'assets/images/gateways/moneris.svg',
             );
            return $settings;
        }, 10, 1);

        $url = 'https://api.github.com/repos/WPManageNinja/moneris-payment-for-paymattic/zipball/1.0.0';

        $latestRelease = AddonHelper::checkUpdateFromGithub('moneris-payment-for-paymattic', 'WPManageNinja', false);

        if ($latestRelease['url']) {
            $url = $latestRelease['url'];
        }

        add_filter('wppayform_payment_method_settings_routes', function($routes) use($url) {
            $routes[] = array (
               'path' => 'moneris',
               'name' => 'moneris',
               'meta' => [
                    'title' => 'Moneris',
                    'Addon' => 'yes',
                    'addon_slug' =>  'moneris-payment-for-paymattic',
                    'source' => 'github',
                    'url' => $url
                ]
            );
           return $routes;
       }, 10, 1);
    }
}